//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//
//
// Use of this sample source code is subject to the terms of the Microsoft
// license agreement under which you licensed this sample source code. If
// you did not accept the terms of the license agreement, you are not
// authorized to use this sample source code. For the terms of the license,
// please see the license agreement between you and Microsoft or, if applicable,
// see the LICENSE.RTF on your install media or the root of your tools installation.
// THE SAMPLE SOURCE CODE IS PROVIDED "AS IS", WITH NO WARRANTIES OR INDEMNITIES.
//

//
// Copyright (C) 2011, UNITEC Co., LTD. All Rights Reserved.
// THIS SOURCE CODE, AND ITS USE AND DISTRIBUTION, IS SUBJECT TO THE TERMS
// AND CONDITIONS OF THE APPLICABLE LICENSE AGREEMENT
//

#ifndef _TCHHID_H_
#define _TCHHID_H_

#include <hidpi.h>
#include <hiddi.h>
#include <cedrv_guid.h>
#include <mtouch.h>

#define HID_USAGE_DIGITIZER_IN_RANGE      ((USAGE) 0x32)
#define HID_USAGE_DIGITIZER_TIP_SWITCH    ((USAGE) 0x42)
#define HID_USAGE_DIGITIZER_CONFIDENCE    ((USAGE) 0x47)
#define HID_USAGE_DIGITIZER_CONTACT_ID    ((USAGE) 0x51)
#define HID_USAGE_DIGITIZER_CONTACT_COUNT ((USAGE) 0x54)
#define HID_USAGE_DIGITIZER_CONTACT_MAX   ((USAGE) 0x55)

#define HID_TOUCH_SIG 'hcTH'
#define TCHHID_MAX_CONTACT		2

#define TCHHID_HID_ATTACH_NAME 	L"TCHHID_HID_ATTACH"

#define TCHHID_MSG_QUEUE_NAME 	L"TCHHID_MSG_QUEUE"
#define TCHHID_MSG_QUEUE_MAX 	64

#define TCHHID_POLLING_TIMEOUT	(10)	// unit:msec

typedef struct {
	DWORD dwCount;
	DWORD dwMaxContact;
	PTCH_BSP_INPUT_INFO pBspInput;
} TCHHID_INFO, *PTCHHID_INFO;

typedef struct _TCH_STREAM {
	HANDLE hMsgQueueReader;
	TCHHID_INFO TouchInfo;
} TCH_STREAM, *PTCH_STREAM;

// Hid Touch data structure.
typedef struct _HID_TOUCH {
    DWORD dwSig;
    HID_HANDLE hDevice;
    PCHID_FUNCS pHidFuncs;
    PHIDP_PREPARSED_DATA phidpPreparsedData;
    HIDP_CAPS hidpCaps;
    HANDLE hThread;

    DWORD dwMaxUsages;
    DWORD dwInstanceId;
    PUSAGE puUsages;

	HANDLE hMsgQueueWriter;
	HANDLE hHidAttach;
#ifdef DEBUG
    BOOL fhThreadInited;
#endif
} HID_TOUCH, *PHID_TOUCH;

#define VALID_HID_TOUCH( p ) \
   ( p && (HID_TOUCH_SIG == p->dwSig) )

#define HID_TOUCH_NAME TEXT("HID TOUCH")
#define DRIVER_HID_TOUCH_GUID TEXT("{25121442-08CA-48dd-91CC-BFC9F790027C}")
#ifndef dim
// Prefer to use _countof() directly, replacing dim()
#pragma deprecated("dim")
#define dim(x) _countof(x)
#endif

#endif

