//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//
//
// Use of this sample source code is subject to the terms of the Microsoft
// license agreement under which you licensed this sample source code. If
// you did not accept the terms of the license agreement, you are not
// authorized to use this sample source code. For the terms of the license,
// please see the license agreement between you and Microsoft or, if applicable,
// see the LICENSE.RTF on your install media or the root of your tools installation.
// THE SAMPLE SOURCE CODE IS PROVIDED "AS IS", WITH NO WARRANTIES OR INDEMNITIES.
//

//
// Copyright (C) 2011, UNITEC Co., LTD. All Rights Reserved.
// THIS SOURCE CODE, AND ITS USE AND DISTRIBUTION, IS SUBJECT TO THE TERMS
// AND CONDITIONS OF THE APPLICABLE LICENSE AGREEMENT
//

#ifndef __BSP_TOUCH_H_
#define __BSP_TOUCH_H_

#if __cplusplus
extern "C" {
#endif

#include <windows.h>
#include <tchddi.h>

#define DEFAULT_THREAD_PRIORITY             109
#define TCH_DRIVER_VERSION 					(_T("1.0.0"))

typedef struct {
	LONG x;
	LONG y;
	TOUCH_PANEL_SAMPLE_FLAGS Flags;
	DWORD dwID;
} TCH_BSP_INPUT_INFO, *PTCH_BSP_INPUT_INFO;

typedef struct {
	DWORD dwMaxContact;
} TCH_BSP_PROPS, *PTCH_BSP_PROPS;

typedef BOOL (WINAPI *PFN_TCH_BSP_INTERRUPT_ENABLE) (
    LPVOID lpBspContext
    );

typedef void (WINAPI *PFN_TCH_BSP_INTERRUPT_DISABLE) (
    LPVOID lpBspContext
    );

typedef void (WINAPI *PFN_TCH_BSP_INTERRUPT_DONE) (
    LPVOID lpBspContext
    );

typedef BOOL (WINAPI *PFN_TCH_BSP_GET_SAMPLE) (
    LPVOID lpBspContext,
	TCH_BSP_INPUT_INFO *pInput,
	INT *count
    );

typedef BOOL (WINAPI *PFN_TCH_BSP_GET_PROPS) (
    LPVOID lpBspContext,
	TCH_BSP_PROPS *pProps
    );

typedef void (WINAPI *PFN_TCH_BSP_POWER_HANDLER) (
    LPVOID lpBspContext,
	BOOL bOff
    );

typedef struct {
    UINT32                version;

    PFN_TCH_BSP_INTERRUPT_ENABLE pfnInterruptEnable;
    PFN_TCH_BSP_INTERRUPT_DISABLE pfnInterruptDisable;
    PFN_TCH_BSP_INTERRUPT_DONE pfnInterruptDone;
    PFN_TCH_BSP_GET_SAMPLE pfnGetSample;
    PFN_TCH_BSP_GET_PROPS pfnGetProps;
    PFN_TCH_BSP_POWER_HANDLER pfnPowerHandler;

} TCH_BSP_INTERFACE_INFO, *PTCH_BSP_INTERFACE_INFO;

HANDLE TchBsp_Init(LPVOID pBspContext, TCH_BSP_INTERFACE_INFO *pBspIfc, DWORD *pdwMaxContact, DWORD dwThredPrio);

#ifdef __cplusplus
}
#endif

#endif // __BSP_TOUCH_H_
